/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2022/08/08
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

#include "debug.h"

/* Global define */
/* Global Variable */
void TIM2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

void TIM2_Int_Init(u16 arr,u16 psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef         NVIC_InitStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);       //ʹTIM2ʱ

    TIM_DeInit(TIM2);
    TIM_UpdateRequestConfig(TIM2,TIM_UpdateSource_Regular);
    TIM_TimeBaseStructure.TIM_Period = arr;                    //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler =psc;                  //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;    //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;//TIMģʽϼģʽ
//  TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);            //ָĲʼTIMxʱλ

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;            //TIM2ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;         //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure);                            //ʼNVIC

//    TIM_ClearFlag(TIM2,TIM_FLAG_Update);
//    TIM_ClearITPendingBit(TIM2,TIM_IT_Update);
    TIM_ITConfig(TIM2,TIM_IT_Update,ENABLE ); //ʹTIM2жϣж

    TIM_Cmd(TIM2, ENABLE); //TIM2ʹ
}

/*********************************************************************
 * @fn      GPIO_Toggle_INIT
 *
 * @brief   Initializes GPIOA.0
 *
 * @return  none
 */
void GPIO_Toggle_INIT(void)
{
    GPIO_InitTypeDef GPIO_InitStructure = {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOD, &GPIO_InitStructure);
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);

    printf("SystemClk:%d\r\n",SystemCoreClock);

    TIM2_Int_Init(10000-1,24000-1);
    GPIO_Toggle_INIT();

    while(1)
    {

    }
}

void TIM2_IRQHandler(void)
{
    static u8 i=0;

    if(TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET) //TIM2жǷ
    {
        TIM_ClearITPendingBit(TIM2,TIM_IT_Update);      //TIM2жϹλ
        GPIO_WriteBit(GPIOD, GPIO_Pin_0, (i==0) ? (i=Bit_SET):(i=Bit_RESET));
    }
}
